AFPCustomizable (Apache FOP Core 2.11 API)
Date: 2025-04-24

org.apache.fop.render.afp

## Interface AFPCustomizable

- All Known Implementing Classes:
    AFPDocumentHandler

      public interface AFPCustomizable

  Interface used to customize the AFP renderer or document handler.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `canEmbedJpeg(boolean canEmbed)` Sets whether or not to JPEG images can be embedded in the AFP document.
    `boolean` | `getFS45()` gets whether images should be FS45
    `int` | `getResolution()` Returns the output/device resolution.
    `boolean` | `getWrapPSeg()` gets whether FS11 and FS45 non-inline images should be wrapped in a page segment
    `boolean` | `isGOCAEnabled()` Indicates whether GOCA is enabled or disabled.
    `boolean` | `isStrokeGOCAText()` Indicates whether to stroke text in GOCA mode or to use text operators where possible.
    `void` | `setBitmapEncodingQuality(float quality)` Sets the image encoding quality setting to use when encoding bitmap images.
    `void` | `setBitsPerPixel(int bitsPerPixel)` Sets the number of bits used per pixel
    `void` | `setCMYKImagesSupported(boolean value)` Controls whether CMYK images (IOCA FS45) are enabled.
    `void` | `setColorImages(boolean colorImages)` Sets whether images are color or not
    `void` | `setDefaultResourceGroupUri(URI uri)` Sets the default resource group URI
    `void` | `setDitheringQuality(float quality)` Sets the dithering quality setting to use when converting images to monochrome images.
    `void` | `setFS45(boolean fs45)` set true if images should be FS45
    `void` | `setGOCAEnabled(boolean enabled)` Controls whether GOCA is enabled or disabled.
    `void` | `setLineWidthCorrection(float correction)` Sets the line width correction
    `void` | `setNativeImagesSupported(boolean nativeImages)` Sets whether images are supported natively or not
    `void` | `setResolution(int resolution)` Sets the output/device resolution
    `void` | `setResourceLevelDefaults(AFPResourceLevelDefaults defaults)` Sets the resource level defaults.
    `void` | `setShadingMode(AFPShadingMode shadingMode)` Sets the shading mode for painting filled rectangles.
    `void` | `setStrokeGOCAText(boolean stroke)` Controls whether to stroke text in GOCA mode or to use text operators where possible.
    `void` | `setWrapPSeg(boolean pSeg)` Sets whether FS11 and FS45 non-inline images should be wrapped in a page segment

- - ### Method Detail

    - #### setBitsPerPixel

          void setBitsPerPixel(int bitsPerPixel)

      Sets the number of bits used per pixel
      Parameters:
        `bitsPerPixel` - number of bits per pixel

    - #### setColorImages

          void setColorImages(boolean colorImages)

      Sets whether images are color or not
      Parameters:
        `colorImages` - color image output

    - #### setNativeImagesSupported

          void setNativeImagesSupported(boolean nativeImages)

      Sets whether images are supported natively or not
      Parameters:
        `nativeImages` - native image support

    - #### setCMYKImagesSupported

          void setCMYKImagesSupported(boolean value)

      Controls whether CMYK images (IOCA FS45) are enabled. By default, support is disabled for wider compatibility. When disabled, any CMYK image is converted to the selected color format.
      Parameters:
        `value` - true to enabled CMYK images

    - #### setShadingMode

          void setShadingMode(AFPShadingMode shadingMode)

      Sets the shading mode for painting filled rectangles.
      Parameters:
        `shadingMode` - the shading mode

    - #### setDitheringQuality

          void setDitheringQuality(float quality)

      Sets the dithering quality setting to use when converting images to monochrome images.
      Parameters:
        `quality` - Defines the desired quality level for the conversion. Valid values: a value between 0.0f (fastest) and 1.0f (best)

    - #### setBitmapEncodingQuality

          void setBitmapEncodingQuality(float quality)

      Sets the image encoding quality setting to use when encoding bitmap images. The default setting is 1.0 which means loss-less encoding. Settings of less than 1.0 allow loss-less encoding schemes like JPEG. The value serves as quality setting for the encoders in that case.
      Parameters:
        `quality` - Defines the desired quality level. Valid values: a value between 0.0f (lowest) and 1.0f (best, loss-less)

    - #### setResolution

          void setResolution(int resolution)

      Sets the output/device resolution
      Parameters:
        `resolution` - the output resolution (dpi)

    - #### setLineWidthCorrection

          void setLineWidthCorrection(float correction)

      Sets the line width correction
      Parameters:
        `correction` - the line width multiplying factor correction

    - #### setWrapPSeg

          void setWrapPSeg(boolean pSeg)

      Sets whether FS11 and FS45 non-inline images should be wrapped in a page segment
      Parameters:
        `pSeg` - true iff images should be wrapped

    - #### setFS45

          void setFS45(boolean fs45)

      set true if images should be FS45
      Parameters:
        `fs45` - true iff images should be FS45

    - #### getWrapPSeg

          boolean getWrapPSeg()

      gets whether FS11 and FS45 non-inline images should be wrapped in a page segment
      Returns:
        true iff images should be wrapped

    - #### getFS45

          boolean getFS45()

      gets whether images should be FS45
      Returns:
        true iff images should be FS45

    - #### getResolution

          int getResolution()

      Returns the output/device resolution.
      Returns:
        the resolution in dpi

    - #### setGOCAEnabled

          void setGOCAEnabled(boolean enabled)

      Controls whether GOCA is enabled or disabled.
      Parameters:
        `enabled` - true if GOCA is enabled, false if it is disabled

    - #### isGOCAEnabled

          boolean isGOCAEnabled()

      Indicates whether GOCA is enabled or disabled.
      Returns:
        true if GOCA is enabled, false if GOCA is disabled

    - #### setStrokeGOCAText

          void setStrokeGOCAText(boolean stroke)

      Controls whether to stroke text in GOCA mode or to use text operators where possible.
      Parameters:
        `stroke` - true to stroke, false to paint with text operators where possible

    - #### isStrokeGOCAText

          boolean isStrokeGOCAText()

      Indicates whether to stroke text in GOCA mode or to use text operators where possible.
      Returns:
        true to stroke, false to paint with text operators where possible

    - #### setDefaultResourceGroupUri

          void setDefaultResourceGroupUri(URI uri)

      Sets the default resource group URI
      Parameters:
        `uri` - the default resource group URI

    - #### setResourceLevelDefaults

          void setResourceLevelDefaults(AFPResourceLevelDefaults defaults)

      Sets the resource level defaults. The object passed in provides information which resource level shall be used by default for various kinds of resources.
      Parameters:
        `defaults` - the resource level defaults

    - #### canEmbedJpeg

          void canEmbedJpeg(boolean canEmbed)

      Sets whether or not to JPEG images can be embedded in the AFP document.
      Parameters:
        `canEmbed` - whether or not to embed JPEG image

Copyright © 2025 Apache Software Foundation. All rights reserved.